<script lang="ts" setup>
import { reactive } from "vue";
import Notification from "@/components/WhiskeyNotification.vue";
import { useRoute } from "vue-router";
import { useQuery, useMutation } from "vue-query";
import { usersGetUser, usersPostUserCredentials } from "@/scripts/api-helper";

const route = useRoute();
const userUid = route.params.uid as string;

const state = reactive({
  error: null as string | null,
  submitLoading: false
});

const fields = reactive({
  userDisplayName: "",
  userEmail: "",
  userSciper: "",
  userUsername: "",
  userPassword: "",
});

const { isLoading, isSuccess, data, error } = useQuery(
  `get-user-${userUid}`,
  async () => {
    const res = await usersGetUser({ uid: userUid });
    fields.userDisplayName = res.data.display_name;
    fields.userEmail = res.data.email;
    fields.userSciper = res.data.sciper?.toString() ?? "";
    fields.userUsername = res.data.username ?? "";
    fields.userPassword = "";
    return res.data;
  },
  {
    onError: () => {
      state.error = "Failed to get user";
    }
  }
);

const {mutate, isLoading: isSubmitLoading} = useMutation(async () => {
  const res = await usersPostUserCredentials({ uid: userUid, username: fields.userUsername, password: fields.userPassword });
  if (!res.ok) {
    state.error = "Failed to update user";
    throw new Error("Failed to updated user")
  }
},
  {
    onError: () => {
      state.error = "Failed to update user";
    }
  }
)
</script>

<template>
  <div class="">
    <div class="mt-5">
      <div class="mb-2 flex justify-between">
        <h2 class="text-2xl text-theme-text-darker">
          Modification d'un utilisateur
        </h2>
        <v-btn exact to="/admin">Retour</v-btn>
      </div>

      <Notification
        :description="state.error || ''"
        :displayed="!!state.error"
        title="Erreur"
      ></Notification>

      <div v-if="isLoading" class=""></div>

      <div v-if="isSuccess" class="">
        <v-card>
          <v-card-item>
            <form @submit.prevent>
              <v-text-field
                v-model="fields.userDisplayName"
                label="Nom d'usage"
                disabled
              ></v-text-field>

              <v-text-field
                v-model="fields.userEmail"
                label="Email"
                type="email"
                disabled
              ></v-text-field>

              <v-text-field
                v-model="fields.userSciper"
                label="Numéro SCIPER (opt.)"
                disabled
              ></v-text-field>

              <v-text-field
                v-model="fields.userUsername"
                label="Nom d'utilisateur"
              ></v-text-field>

              <v-text-field
                v-model="fields.userPassword"
                label="Mot de passe"
                type="password"
              ></v-text-field>
            </form>
          </v-card-item>
          <v-card-actions class="flex justify-center">
            <v-btn color="success" @click="mutate" :loading="isSubmitLoading">
              Modifier
            </v-btn>
          </v-card-actions>
        </v-card>
      </div>
    </div>
  </div>
</template>

<style></style>
